Index: drivers/filesystems/btrfs/fsctl.c
===================================================================
--- drivers/filesystems/btrfs/fsctl.c	(révision 75772)
+++ drivers/filesystems/btrfs/fsctl.c	(copie de travail)
@@ -2873,6 +4795,11 @@
             Status = STATUS_INVALID_DEVICE_REQUEST;
             break;
 
+        case FSCTL_OPLOCK_BREAK_ACK_NO_2:
+            WARN("STUB: FSCTL_OPLOCK_BREAK_ACK_NO_2\n");
+            Status = STATUS_INVALID_DEVICE_REQUEST;
+            break;
+
         case FSCTL_OPBATCH_ACK_CLOSE_PENDING:
             WARN("STUB: FSCTL_OPBATCH_ACK_CLOSE_PENDING\n");
             Status = STATUS_INVALID_DEVICE_REQUEST;
@@ -2883,6 +4810,11 @@
             Status = STATUS_INVALID_DEVICE_REQUEST;
             break;
 
+        case FSCTL_REQUEST_FILTER_OPLOCK:
+            WARN("STUB: FSCTL_REQUEST_FILTER_OPLOCK\n");
+            Status = STATUS_INVALID_DEVICE_REQUEST;
+            break;
+
         case FSCTL_LOCK_VOLUME:
             Status = lock_volume(DeviceObject->DeviceExtension, Irp);
             break;
@@ -2915,12 +4847,11 @@
             break;
 
         case FSCTL_GET_COMPRESSION:
-            Status = get_compression(DeviceObject->DeviceExtension, Irp);
+            Status = get_compression(Irp);
             break;
 
         case FSCTL_SET_COMPRESSION:
-            WARN("STUB: FSCTL_SET_COMPRESSION\n");
-            Status = STATUS_INVALID_DEVICE_REQUEST;
+            Status = set_compression(Irp);
             break;
 
         case FSCTL_SET_BOOTLOADER_ACCESSED:
@@ -2928,11 +4859,6 @@
             Status = STATUS_INVALID_DEVICE_REQUEST;
             break;
 
-        case FSCTL_OPLOCK_BREAK_ACK_NO_2:
-            WARN("STUB: FSCTL_OPLOCK_BREAK_ACK_NO_2\n");
-            Status = STATUS_INVALID_DEVICE_REQUEST;
-            break;
-
         case FSCTL_INVALIDATE_VOLUMES:
             Status = invalidate_volumes(Irp);
             break;
@@ -2942,14 +4868,8 @@
             Status = STATUS_INVALID_DEVICE_REQUEST;
             break;
 
-        case FSCTL_REQUEST_FILTER_OPLOCK:
-            WARN("STUB: FSCTL_REQUEST_FILTER_OPLOCK\n");
-            Status = STATUS_INVALID_DEVICE_REQUEST;
-            break;
-
         case FSCTL_FILESYSTEM_GET_STATISTICS:
-            Status = fs_get_statistics(DeviceObject, IrpSp->FileObject, Irp->AssociatedIrp.SystemBuffer,
-                                       IrpSp->Parameters.FileSystemControl.OutputBufferLength, &Irp->IoStatus.Information);
+            Status = fs_get_statistics(Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.FileSystemControl.OutputBufferLength, &Irp->IoStatus.Information);
             break;
 
         case FSCTL_GET_NTFS_VOLUME_DATA:
@@ -3054,7 +4974,7 @@
             break;
 
         case FSCTL_QUERY_ALLOCATED_RANGES:
-            Status = query_ranges(DeviceObject->DeviceExtension, IrpSp->FileObject, IrpSp->Parameters.FileSystemControl.Type3InputBuffer,
+            Status = query_ranges(IrpSp->FileObject, IrpSp->Parameters.FileSystemControl.Type3InputBuffer,
                                   IrpSp->Parameters.FileSystemControl.InputBufferLength, Irp->UserBuffer,
                                   IrpSp->Parameters.FileSystemControl.OutputBufferLength, &Irp->IoStatus.Information);
             break;
@@ -3309,46 +5229,66 @@
             WARN("STUB: FSCTL_TXFS_READ_BACKUP_INFORMATION2\n");
             Status = STATUS_INVALID_DEVICE_REQUEST;
             break;
-            
+
         case FSCTL_CSV_CONTROL:
             WARN("STUB: FSCTL_CSV_CONTROL\n");
             Status = STATUS_INVALID_DEVICE_REQUEST;
             break;
 #endif
+        // TRACE rather than WARN because Windows 10 spams this undocumented fsctl
+        case FSCTL_QUERY_VOLUME_CONTAINER_STATE:
+            TRACE("STUB: FSCTL_QUERY_VOLUME_CONTAINER_STATE\n");
+            Status = STATUS_INVALID_DEVICE_REQUEST;
+            break;
+
+        case FSCTL_GET_INTEGRITY_INFORMATION:
+            Status = get_integrity_information(DeviceObject->DeviceExtension, IrpSp->FileObject, map_user_buffer(Irp, NormalPagePriority),
+                                               IrpSp->Parameters.FileSystemControl.OutputBufferLength);
+            break;
+
+        case FSCTL_SET_INTEGRITY_INFORMATION:
+            Status = set_integrity_information(IrpSp->FileObject, Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.FileSystemControl.InputBufferLength);
+            break;
+
+        case FSCTL_DUPLICATE_EXTENTS_TO_FILE:
+            Status = duplicate_extents(DeviceObject->DeviceExtension, IrpSp->FileObject, Irp->AssociatedIrp.SystemBuffer,
+                                       IrpSp->Parameters.FileSystemControl.InputBufferLength, Irp);
+            break;
+
         case FSCTL_BTRFS_GET_FILE_IDS:
-            Status = get_file_ids(IrpSp->FileObject, map_user_buffer(Irp), IrpSp->Parameters.FileSystemControl.OutputBufferLength);
+            Status = get_file_ids(IrpSp->FileObject, map_user_buffer(Irp, NormalPagePriority), IrpSp->Parameters.FileSystemControl.OutputBufferLength);
             break;
-            
+
         case FSCTL_BTRFS_CREATE_SUBVOL:
-            Status = create_subvol(DeviceObject->DeviceExtension, IrpSp->FileObject, map_user_buffer(Irp), IrpSp->Parameters.FileSystemControl.OutputBufferLength, Irp);
+            Status = create_subvol(DeviceObject->DeviceExtension, IrpSp->FileObject, Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.FileSystemControl.InputBufferLength, Irp);
             break;
-            
+
         case FSCTL_BTRFS_CREATE_SNAPSHOT:
-            Status = create_snapshot(DeviceObject->DeviceExtension, IrpSp->FileObject, map_user_buffer(Irp), IrpSp->Parameters.FileSystemControl.OutputBufferLength, Irp);
+            Status = create_snapshot(DeviceObject->DeviceExtension, IrpSp->FileObject, Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.FileSystemControl.InputBufferLength, Irp);
             break;
-            
+
         case FSCTL_BTRFS_GET_INODE_INFO:
-            Status = get_inode_info(IrpSp->FileObject, map_user_buffer(Irp), IrpSp->Parameters.FileSystemControl.OutputBufferLength);
+            Status = get_inode_info(IrpSp->FileObject, map_user_buffer(Irp, NormalPagePriority), IrpSp->Parameters.FileSystemControl.OutputBufferLength);
             break;
-            
+
         case FSCTL_BTRFS_SET_INODE_INFO:
-            Status = set_inode_info(IrpSp->FileObject, map_user_buffer(Irp), IrpSp->Parameters.FileSystemControl.OutputBufferLength);
+            Status = set_inode_info(IrpSp->FileObject, Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.FileSystemControl.InputBufferLength, Irp);
             break;
-            
+
         case FSCTL_BTRFS_GET_DEVICES:
-            Status = get_devices(DeviceObject->DeviceExtension, map_user_buffer(Irp), IrpSp->Parameters.FileSystemControl.OutputBufferLength);
+            Status = get_devices(DeviceObject->DeviceExtension, map_user_buffer(Irp, NormalPagePriority), IrpSp->Parameters.FileSystemControl.OutputBufferLength);
             break;
-            
+
         case FSCTL_BTRFS_GET_USAGE:
-            Status = get_usage(DeviceObject->DeviceExtension, map_user_buffer(Irp), IrpSp->Parameters.FileSystemControl.OutputBufferLength);
+            Status = get_usage(DeviceObject->DeviceExtension, map_user_buffer(Irp, NormalPagePriority), IrpSp->Parameters.FileSystemControl.OutputBufferLength, Irp);
             break;
-            
+
         case FSCTL_BTRFS_START_BALANCE:
             Status = start_balance(DeviceObject->DeviceExtension, Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.FileSystemControl.InputBufferLength, Irp->RequestorMode);
             break;
-            
+
         case FSCTL_BTRFS_QUERY_BALANCE:
-            Status = query_balance(DeviceObject->DeviceExtension, map_user_buffer(Irp), IrpSp->Parameters.FileSystemControl.OutputBufferLength);
+            Status = query_balance(DeviceObject->DeviceExtension, map_user_buffer(Irp, NormalPagePriority), IrpSp->Parameters.FileSystemControl.OutputBufferLength);
             break;
 
         case FSCTL_BTRFS_PAUSE_BALANCE:
@@ -3358,25 +5298,91 @@
         case FSCTL_BTRFS_RESUME_BALANCE:
             Status = resume_balance(DeviceObject->DeviceExtension, Irp->RequestorMode);
             break;
-            
+
         case FSCTL_BTRFS_STOP_BALANCE:
             Status = stop_balance(DeviceObject->DeviceExtension, Irp->RequestorMode);
             break;
-            
+
         case FSCTL_BTRFS_ADD_DEVICE:
-            Status = add_device(DeviceObject->DeviceExtension, Irp, Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.FileSystemControl.InputBufferLength, Irp->RequestorMode);
+            Status = add_device(DeviceObject->DeviceExtension, Irp, Irp->RequestorMode);
             break;
-            
+
         case FSCTL_BTRFS_REMOVE_DEVICE:
             Status = remove_device(DeviceObject->DeviceExtension, Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.FileSystemControl.InputBufferLength, Irp->RequestorMode);
-        break;
-        
+            break;
+
         case FSCTL_BTRFS_GET_UUID:
-            Status = query_uuid(DeviceObject->DeviceExtension, map_user_buffer(Irp), IrpSp->Parameters.FileSystemControl.OutputBufferLength);
-        break;
+            Status = query_uuid(DeviceObject->DeviceExtension, map_user_buffer(Irp, NormalPagePriority), IrpSp->Parameters.FileSystemControl.OutputBufferLength);
+            break;
 
+        case FSCTL_BTRFS_START_SCRUB:
+            Status = start_scrub(DeviceObject->DeviceExtension, Irp->RequestorMode);
+            break;
+
+        case FSCTL_BTRFS_QUERY_SCRUB:
+            Status = query_scrub(DeviceObject->DeviceExtension, Irp->RequestorMode, map_user_buffer(Irp, NormalPagePriority), IrpSp->Parameters.FileSystemControl.OutputBufferLength);
+            break;
+
+        case FSCTL_BTRFS_PAUSE_SCRUB:
+            Status = pause_scrub(DeviceObject->DeviceExtension, Irp->RequestorMode);
+            break;
+
+        case FSCTL_BTRFS_RESUME_SCRUB:
+            Status = resume_scrub(DeviceObject->DeviceExtension, Irp->RequestorMode);
+            break;
+
+        case FSCTL_BTRFS_STOP_SCRUB:
+            Status = stop_scrub(DeviceObject->DeviceExtension, Irp->RequestorMode);
+            break;
+
+        case FSCTL_BTRFS_RESET_STATS:
+            Status = reset_stats(DeviceObject->DeviceExtension, Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.FileSystemControl.InputBufferLength, Irp->RequestorMode);
+            break;
+
+        case FSCTL_BTRFS_MKNOD:
+            Status = mknod(DeviceObject->DeviceExtension, IrpSp->FileObject, Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.FileSystemControl.InputBufferLength, Irp);
+            break;
+
+        case FSCTL_BTRFS_RECEIVED_SUBVOL:
+            Status = recvd_subvol(DeviceObject->DeviceExtension, IrpSp->FileObject, Irp->AssociatedIrp.SystemBuffer,
+                                  IrpSp->Parameters.FileSystemControl.InputBufferLength, Irp->RequestorMode);
+            break;
+
+        case FSCTL_BTRFS_GET_XATTRS:
+            Status = fsctl_get_xattrs(DeviceObject->DeviceExtension, IrpSp->FileObject, Irp->UserBuffer, IrpSp->Parameters.FileSystemControl.OutputBufferLength, Irp->RequestorMode);
+            break;
+
+        case FSCTL_BTRFS_SET_XATTR:
+            Status = fsctl_set_xattr(DeviceObject->DeviceExtension, IrpSp->FileObject, Irp->AssociatedIrp.SystemBuffer,
+                                     IrpSp->Parameters.FileSystemControl.InputBufferLength, Irp);
+            break;
+
+        case FSCTL_BTRFS_RESERVE_SUBVOL:
+            Status = reserve_subvol(DeviceObject->DeviceExtension, IrpSp->FileObject, Irp);
+            break;
+
+        case FSCTL_BTRFS_FIND_SUBVOL:
+            Status = find_subvol(DeviceObject->DeviceExtension, Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.FileSystemControl.InputBufferLength,
+                                 Irp->UserBuffer, IrpSp->Parameters.FileSystemControl.OutputBufferLength, Irp);
+            break;
+
+        case FSCTL_BTRFS_SEND_SUBVOL:
+            Status = send_subvol(DeviceObject->DeviceExtension, Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.FileSystemControl.InputBufferLength,
+                                 IrpSp->FileObject, Irp);
+            break;
+
+        case FSCTL_BTRFS_READ_SEND_BUFFER:
+            Status = read_send_buffer(DeviceObject->DeviceExtension, IrpSp->FileObject, map_user_buffer(Irp, NormalPagePriority), IrpSp->Parameters.FileSystemControl.OutputBufferLength,
+                                      &Irp->IoStatus.Information, Irp->RequestorMode);
+            break;
+
+        case FSCTL_BTRFS_RESIZE:
+            Status = resize_device(DeviceObject->DeviceExtension, Irp->AssociatedIrp.SystemBuffer,
+                                   IrpSp->Parameters.FileSystemControl.InputBufferLength, Irp);
+            break;
+
         default:
-            TRACE("unknown control code %x (DeviceType = %x, Access = %x, Function = %x, Method = %x)\n",
+            WARN("unknown control code %x (DeviceType = %x, Access = %x, Function = %x, Method = %x)\n",
                           IrpSp->Parameters.FileSystemControl.FsControlCode, (IrpSp->Parameters.FileSystemControl.FsControlCode & 0xff0000) >> 16,
                           (IrpSp->Parameters.FileSystemControl.FsControlCode & 0xc000) >> 14, (IrpSp->Parameters.FileSystemControl.FsControlCode & 0x3ffc) >> 2,
                           IrpSp->Parameters.FileSystemControl.FsControlCode & 0x3);
@@ -3383,6 +5389,6 @@
             Status = STATUS_INVALID_DEVICE_REQUEST;
             break;
     }
-    
+
     return Status;
 }
Index: drivers/filesystems/btrfs/galois.c
===================================================================
--- drivers/filesystems/btrfs/galois.c	(révision 75772)
+++ drivers/filesystems/btrfs/galois.c	(copie de travail)
@@ -1,17 +1,17 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
@@ -95,20 +95,12 @@
 // https://www.kernel.org/pub/linux/kernel/people/hpa/raid6.pdf
 
 #ifdef _AMD64_
-#ifdef __REACTOS__
-static __inline UINT64 galois_double_mask64(UINT64 v) {
-#else
-static UINT64 __inline galois_double_mask64(UINT64 v) {
-#endif
+__inline static UINT64 galois_double_mask64(UINT64 v) {
     v &= 0x8080808080808080;
     return (v << 1) - (v >> 7);
 }
 #else
-#ifdef __REACTOS__
-static __inline UINT32 galois_double_mask32(UINT32 v) {
-#else
-static UINT32 __inline galois_double_mask32(UINT32 v) {
-#endif
+__inline static UINT32 galois_double_mask32(UINT32 v) {
     v &= 0x80808080;
     return (v << 1) - (v >> 7);
 }
@@ -116,15 +108,15 @@
 
 void galois_double(UINT8* data, UINT32 len) {
     // FIXME - SIMD?
-    
+
 #ifdef _AMD64_
     while (len > sizeof(UINT64)) {
         UINT64 v = *((UINT64*)data), vv;
-        
+
         vv = (v << 1) & 0xfefefefefefefefe;
         vv ^= galois_double_mask64(v) & 0x1d1d1d1d1d1d1d1d;
         *((UINT64*)data) = vv;
-        
+
         data += sizeof(UINT64);
         len -= sizeof(UINT64);
     }
@@ -131,16 +123,16 @@
 #else
     while (len > sizeof(UINT32)) {
         UINT32 v = *((UINT32*)data), vv;
-        
+
         vv = (v << 1) & 0xfefefefe;
         vv ^= galois_double_mask32(v) & 0x1d1d1d1d;
         *((UINT32*)data) = vv;
-        
+
         data += sizeof(UINT32);
         len -= sizeof(UINT32);
     }
 #endif
-    
+
     while (len > 0) {
         data[0] = (data[0] << 1) ^ ((data[0] & 0x80) ? 0x1d : 0);
         data++;
Index: drivers/filesystems/btrfs/guid.c
===================================================================
--- drivers/filesystems/btrfs/guid.c	(nonexistent)
+++ drivers/filesystems/btrfs/guid.c	(copie de travail)
@@ -0,0 +1,5 @@
+/* Specific glue for ReactOS/GUID */
+
+#include <ntifs.h>
+#include <initguid.h>
+#include <ntddstor.h>

Modification de propriétés sur drivers/filesystems/btrfs/guid.c
___________________________________________________________________
Added: svn:eol-style
## -0,0 +1 ##
+native
\ No newline at end of property
